package jrummikub.control.network;

import jrummikub.control.GameControl;
import jrummikub.control.RoundControl;
import jrummikub.control.SaveControl;
import jrummikub.model.GameSettings;
import jrummikub.model.IRoundState;
import jrummikub.util.IListener;
import jrummikub.view.IView;

public class NetworkGameControl extends GameControl {
	private IConnectionControl connectionControl;
	private boolean host;

	public NetworkGameControl(GameSettings gameSettings, SaveControl saveControl,
			IView view, IConnectionControl connectionControl, boolean host) {
		super(gameSettings, saveControl, view);

		this.connectionControl = connectionControl;
		this.host = host;
	}

	@Override
	public void startGame() {
		connections.add(connectionControl.getRoundStartEvent().add(new IListener() {
			@Override
			public void handle() {
				startRound();
			}
		}));

		if (host) {
			connectionControl.startRound();
		}
	}

	@Override
	protected IRoundState createRoundState() {
		return host ? super.createRoundState() : null;
	}

	@Override
	protected RoundControl createRoundControl(IRoundState roundState) {
		return new NetworkRoundControl(roundState, view, connectionControl, host);
	}
}
